mroot {mgcv} | R Documentation

## Smallest square root of matrix

### Description

Find a square root of a positive semi-definite matrix, having as few columns as possible. Uses either pivoted choleski decomposition or singular value decomposition to do this.

### Usage

    mroot(A,rank=NULL,method="chol")

### Arguments

`A` | The positive semi-definite matrix, a square root of which is to be found.
`rank` | if the rank of the matrix `A` is known then it should be supplied.
`method` | `"chol"` to use pivoted choloeski decompositon, which is fast but tends to over-estimate rank. `"svd"` to use singular value decomposition, which is slow, but is the most accurate way to estimate rank.

### Details

The routine uses an LAPACK SVD routine, or the LINPACK pivoted Choleski routine. It is primarily of use for turning penalized regression problems into ordinary regression problems.

### Value

A matrix, B with as many columns as the rank of A, and such that A=BB'.

### Author(s)

Simon N. Wood simon.wood@r-project.org

### Examples

      set.seed(0)
      a <- matrix(runif(24),6,4)
      A <- a%*%t(a) ## A is +ve semi-definite, rank 4
      B <- mroot(A) ## default pivoted choleski method
      tol <- 100*.Machine$double.eps
      chol.err <- max(abs(A-B%*%t(B)));chol.err
      if (chol.err>tol) warning("mroot (chol) suspect")
      B <- mroot(A,method="svd") ## svd method
      svd.err <- max(abs(A-B%*%t(B)));svd.err
      if (svd.err>tol) warning("mroot (svd) suspect")

[Package mgcv version 1.4-1.1 Index]